from EStat.Templating import *

class TemplateGenericQuiz(Template):
    'Generic quiz template - developed for use with eBooks (based on GenericQuiz).'

    tags = [ 'eBook' ]
    engines = ['Python_script']

    inputs = '''
questiontext = Text('What is the question?')
questionmulti = Boolean('Is it multiple choice?')
if questionmulti:
    numanswers = Integer('How many possible answers?')
    for i in range(0, int(numanswers)):
        context['answer' + str(i)] = Text('Answer ' + str(i + 1))
    answers = []
    for i in range(0, int(numanswers)):
        answers.append(str(context['answer' + str(i)]))
    answermulti = Boolean('Is it multiple answer?')
    if answermulti:
        correctanswer = List('What are the correct answers?', answers)
        useranswer = List(str(questiontext), answers)
    else:
        correctanswer = Text('What is the correct answer?', answers)
        useranswer = Text(str(questiontext), answers)
else:
    correctanswer = Text('What is the correct answer?')
    useranswer = Text(str(questiontext))
'''

    pythonscript = '''
from EStat.Templating import HTMLOutput
if questionmulti and answermulti:
    answers = set(useranswer)
    correctanswers = set(correctanswer)
else:
    answers = set([str(useranswer)])
    correctanswers = set([str(correctanswer)])   

if set.union(answers, correctanswers) == answers:
    answer = '<p><strong>Correct <img src="smile.png" alt="Smiling face" title="Smiling face" /> - well done!</strong></p>'
else:
    answer = '<p><strong>Wrong <img src="thoughtful.png" alt="Thoughtful face" title="Thoughtful face" /> ...try again?</strong></p>'

outputs['feedback'] = HTMLOutput(answer, description = 'Answer to the question')
'''
